osg::AnimationPath Class Reference

`#include <AnimationPath>`

Inheritance diagram for osg::AnimationPath:

## Classes

class | ControlPoint

## Public Types

enum | LoopMode { SWING , LOOP , NO_LOOPING }
typedef std::map< double, ControlPoint > | TimeControlPointMap
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| AnimationPath ()
| AnimationPath (const AnimationPath &ap, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Object (osg, AnimationPath)
bool | getMatrix (double time, Matrixf &matrix) const
bool | getMatrix (double time, Matrixd &matrix) const
bool | getInverse (double time, Matrixf &matrix) const
bool | getInverse (double time, Matrixd &matrix) const
virtual bool | getInterpolatedControlPoint (double time, ControlPoint &controlPoint) const
void | insert (double time, const ControlPoint &controlPoint)
double | getFirstTime () const
double | getLastTime () const
double | getPeriod () const
void | setLoopMode (LoopMode lm)
LoopMode | getLoopMode () const
void | setTimeControlPointMap (TimeControlPointMap &tcpm)
TimeControlPointMap & | getTimeControlPointMap ()
const TimeControlPointMap & | getTimeControlPointMap () const
bool | empty () const
void | clear ()
void | read (std::istream &in)
void | write (std::ostream &out) const
void | write (TimeControlPointMap::const_iterator itr, std::ostream &out) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~AnimationPath ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

TimeControlPointMap | _timeControlPointMap
LoopMode | _loopMode
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

AnimationPath encapsulates a time varying transformation pathway. Can be used for updating camera position and model object position. AnimationPathCallback can be attached directly to Transform nodes to move subgraphs around the scene.

## Member Typedef Documentation

## TimeControlPointMap

typedef std::map<double,ControlPoint> osg::AnimationPath::TimeControlPointMap

## Member Enumeration Documentation

## LoopMode

enum osg::AnimationPath::LoopMode

Enumerator
SWING |
LOOP |
NO_LOOPING |

## Constructor & Destructor Documentation

## AnimationPath() [1/2]

osg::AnimationPath::AnimationPath | ( |  | ) |

inline

References _loopMode, and LOOP.

Referenced by AnimationPath(), and META_Object().

## AnimationPath() [2/2]

osg::AnimationPath::AnimationPath | ( | const AnimationPath & | ap,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

inline

References _loopMode, _timeControlPointMap, AnimationPath(), osg::Object::Object(), and osg::CopyOp::SHALLOW_COPY.

## ~AnimationPath()

virtual osg::AnimationPath::~AnimationPath | ( |  | ) |

inline protected virtual

## Member Function Documentation

## clear()

void osg::AnimationPath::clear | ( |  | ) |

inline

References _timeControlPointMap.

## empty()

bool osg::AnimationPath::empty | ( |  | ) | const

inline

References _timeControlPointMap.

## getFirstTime()

double osg::AnimationPath::getFirstTime | ( |  | ) | const

inline

References _timeControlPointMap.

Referenced by getPeriod().

## getInterpolatedControlPoint()

virtual bool osg::AnimationPath::getInterpolatedControlPoint | ( | double | time,
|  | ControlPoint & | controlPoint ) const

virtual

Given a specific time, return the local ControlPoint frame for a point.

Referenced by getInverse(), getInverse(), getMatrix(), and getMatrix().

## getInverse() [1/2]

bool osg::AnimationPath::getInverse | ( | double | time,
|  | Matrixd & | matrix ) const

inline

References getInterpolatedControlPoint(), and osg::AnimationPath::ControlPoint::getInverse().

## getInverse() [2/2]

bool osg::AnimationPath::getInverse | ( | double | time,
|  | Matrixf & | matrix ) const

inline

Given a specific time, return the inverse transformation matrix for a point.

References getInterpolatedControlPoint(), and osg::AnimationPath::ControlPoint::getInverse().

## getLastTime()

double osg::AnimationPath::getLastTime | ( |  | ) | const

inline

References _timeControlPointMap.

Referenced by getPeriod().

## getLoopMode()

LoopMode osg::AnimationPath::getLoopMode | ( |  | ) | const

inline

References _loopMode.

## getMatrix() [1/2]

bool osg::AnimationPath::getMatrix | ( | double | time,
|  | Matrixd & | matrix ) const

inline

Given a specific time, return the transformation matrix for a point.

References getInterpolatedControlPoint(), and osg::AnimationPath::ControlPoint::getMatrix().

## getMatrix() [2/2]

bool osg::AnimationPath::getMatrix | ( | double | time,
|  | Matrixf & | matrix ) const

inline

Given a specific time, return the transformation matrix for a point.

References getInterpolatedControlPoint(), and osg::AnimationPath::ControlPoint::getMatrix().

## getPeriod()

double osg::AnimationPath::getPeriod | ( |  | ) | const

inline

References getFirstTime(), and getLastTime().

## getTimeControlPointMap() [1/2]

TimeControlPointMap & osg::AnimationPath::getTimeControlPointMap | ( |  | ) |

inline

References _timeControlPointMap.

## getTimeControlPointMap() [2/2]

const TimeControlPointMap & osg::AnimationPath::getTimeControlPointMap | ( |  | ) | const

inline

References _timeControlPointMap.

## insert()

void osg::AnimationPath::insert | ( | double | time,
|  | const ControlPoint & | controlPoint )

Insert a control point into the AnimationPath.

## META_Object()

osg::AnimationPath::META_Object | ( | osg | ,
|  | AnimationPath | )

References AnimationPath().

## read()

void osg::AnimationPath::read | ( | std::istream & | in | ) |

Read the animation path from a flat ASCII file stream.

## setLoopMode()

void osg::AnimationPath::setLoopMode | ( | LoopMode | lm | ) |

inline

References _loopMode.

## setTimeControlPointMap()

void osg::AnimationPath::setTimeControlPointMap | ( | TimeControlPointMap & | tcpm | ) |

inline

References _timeControlPointMap.

## write() [1/2]

void osg::AnimationPath::write | ( | std::ostream & | out | ) | const

Write the animation path to a flat ASCII file stream.

## write() [2/2]

void osg::AnimationPath::write | ( | TimeControlPointMap::const_iterator | itr,
|  | std::ostream & | out ) const

Write the control point to a flat ASCII file stream.

## Member Data Documentation

## _loopMode

LoopMode osg::AnimationPath::_loopMode

protected

Referenced by AnimationPath(), AnimationPath(), getLoopMode(), and setLoopMode().

## _timeControlPointMap

TimeControlPointMap osg::AnimationPath::_timeControlPointMap

protected

Referenced by AnimationPath(), clear(), empty(), getFirstTime(), getLastTime(), getTimeControlPointMap(), getTimeControlPointMap(), and setTimeControlPointMap().

The documentation for this class was generated from the following file:

- AnimationPath